/* ISOAPP.H
 * ISO-14230 box application specific header file
 * 3/15/02 Prune
 */
#include "isobox.h"

#ifndef ISOAPP_H_INCLUDED

#define ISOAPP_H_INCLUDED

#define NUM_RETRIES (5)

#ifdef ISOAPPMAIN
#define ISOAPPDECL 
#else
#define ISOAPPDECL extern
#endif

/*** ISO-14230 BOX ROUTINES ***/
ISOAPPDECL void QueryStatus(void);
ISOAPPDECL void SetLineVoltage(void);
ISOAPPDECL void QueryKeyword(void);
ISOAPPDECL int FastInit(void);
ISOAPPDECL int SlowInit(void);
ISOAPPDECL void ClearBuffers(void);
ISOAPPDECL void SendMessage(void);
ISOAPPDECL void QueryRevision(void);

/*** ISO-14230 BOX SUBROUTINES ***/
ISOAPPDECL int GetParameters(void);
ISOAPPDECL int Initialize(void);
ISOAPPDECL int GetHex(unsigned char *hexvalptr);

ISOAPPDECL unsigned char Method;
ISOAPPDECL unsigned char Source;
ISOAPPDECL unsigned char Target;
ISOAPPDECL unsigned char Addressing;
ISOAPPDECL unsigned char string[256];

#endif
