/* ISOBOX.H
 * ISO-14230 box header file
 * 3/15/02 Prune
 */
#ifndef ISOBOX_H_INCLUDED

#define ISOBOX_H_INCLUDED

#ifdef ISOMAIN
#define ISODECL
#else
#define ISODECL extern
extern const unsigned char NotResp[];
#endif

#define BAUDRATE (19200UL) /* Do not change this for ISO-14230 box */
#define STATUS_OK ('O')

typedef enum {
    RESP_STATUS=0,
    RESP_KEYWORD,
    RESP_REVISION
} RespEnum;

/*** ISO-14230 BOX SUBROUTINES ***/

/*** ALL ROUTINES RETURN 0 IF SUCCESSFUL ***/
/*** ALL ROUTINES RETURN -1 IF FAILURE ***/

ISODECL int SendCommand(unsigned char x);
ISODECL int SendMultiByteCommand(unsigned char len);  /* max len=10 */
ISODECL int RecvInitResp(unsigned int *respptr, RespEnum RespType);
ISODECL char *GetErrorCode(unsigned char code);

ISODECL unsigned char ISOarg[10];

#endif
