/* ISOERR.H
 * ISO-14230 box error code header file
 * 3/11/02 Prune
 */
#ifndef ISOERR_H_INCLUDED

#define ISOERR_H_INCLUDED

#define ERROR_FAILED_BRING_K_AND_L_LOW (0x00)
#define ERROR_FAILED_BRING_K_LOW (0x01)
#define ERROR_FAILED_BRING_L_LOW (0x02)
#define ERROR_K_AND_L_WERE_STUCK_LOW (0x03)
#define ERROR_K_WAS_STUCK_LOW (0x04)
#define ERROR_L_WAS_STUCK_LOW (0x05)
#define ERROR_K_AND_L_ARE_STUCK_LOW (0x06)
#define ERROR_K_IS_STUCK_LOW (0x07)
#define ERROR_L_IS_STUCK_LOW (0x08) /* last of K,L line errors */
#define ERROR_NO_RESP_RECV_TO_INIT (0x09)
#define ERROR_IMPROPER_SYNC_RECV (0x0A)
#define ERROR_IMPROPER_INV_ADDR_RECV (0x0B)
#define ERROR_IMPROPER_START_COMM_POS_RESP (0x0C)
#define ERROR_BAD_START_COMM_POS_RESP_CKS (0x0D) /* last of init errors */
#define ERROR_INVALID_CHECKSUM_FROM_PC (0x20)
#define ERROR_INVALID_COMMAND_FROM_PC (0x21) /* last of errors cleared by
					      * non-status command
					      */
#define ERROR_RECEIVE_BUFFER_OVERFLOW (0x30)	 
#define ERROR_TRANSMIT_BUFFER_OVERFLOW (0x31)
#define ERROR_NULL (0x4F)
#define ERROR_ROM_CHECKSUM_ERROR (0xE0)

#endif
