/* NISSAN.H
 * Nissan Parameter Header File
 * 03/18/02 Prune
 */
#ifndef NISSAN_H_INCLUDED

#define NISSAN_H_INCLUDED

#ifdef NISSAN_MAIN
#define NISSAN_DECL 
#else
#define NISSAN_DECL extern
#endif

#define HEADER(x) ((Addressing=='P')?(0x80|(x)):(0xC0|(x)))
#define PrintAndWrite(x) printf(" %02X",(x)); MyWriteChar(x); Checksum+=x;

typedef enum {
    PARAM_ID_OPTION=0,
    PARAM_TRANSMISSION_MODE,
    PARAM_MAX_NUM_OF_RESP_TO_SEND,
    PARAM_RECORD_LOCAL_ID,
    PARAM_RECORD_COMMON_ID_HIGH_BYTE,
    PARAM_RECORD_COMMON_ID_LOW_BYTE,
    PARAM_WRITE_DATA_LOCAL_ID,
    PARAM_CONTROL_OPTION_1,
    PARAM_CONTROL_OPTION_2,
    PARAM_RECORD_ID,
    PARAM_IO_LOCAL_ID,
    PARAM_IO_CTRL_OPTION_1_HIGH_BYTE,
    PARAM_IO_CTRL_OPTION_1_LOW_BYTE,
    PARAM_IO_CTRL_OPTION_2,
    PARAM_VALVE_CTRL_OPTION_1,
    PARAM_VALVE_CTRL_OPTION_2,
    PARAM_EEPROM_DUMP_CTRL_OPTION_1,
    NUMBER_OF_PARAMETERS
} ParmEnum;

NISSAN_DECL unsigned char Parameter[NUMBER_OF_PARAMETERS];
NISSAN_DECL unsigned char Checksum;

NISSAN_DECL char *GetNamedParameter(ParmEnum x);
NISSAN_DECL void LoadParameters(void);
NISSAN_DECL void SaveParameters(void);

NISSAN_DECL void ValveActivation(void);
NISSAN_DECL void EEPROMDump(void);
NISSAN_DECL void ReadSoftwareVersion(void);
NISSAN_DECL void ReadFreezeFrameData(void); 
NISSAN_DECL void ClearDiagnosticInformation(void); 
NISSAN_DECL void ReadECUIdentification(void); 
NISSAN_DECL void ReadDataByLocalIdentifier(void);
NISSAN_DECL void ReadDataByCommonIdentifier(void); 
NISSAN_DECL void InputOutputControlByLocalIdentifier(void);
NISSAN_DECL void WriteDataByLocalIdentifier(void); 
NISSAN_DECL void ReadDiagnosticTroubleCodesWithOptionByte(void); 
NISSAN_DECL void ReadTimeOfDiagnosticTroubleCodes(void); 
NISSAN_DECL void ClearDiagnosticTroubleCodes(void);
NISSAN_DECL void SimplyDynamicallyDefineLocalID(void); 
NISSAN_DECL void TesterPresent(void);

#endif
