Option Strict Off
Option Explicit On
Module Main

    Public Const XMIT_STATUS As Long = &H1
    Public Const XMIT_REVISION As Long = &H2
    Public Const XMIT_RUN As Long = &H4
    Public Const XMIT_FAST_INIT As Long = &H8
    Public Const XMIT_SLOW_INIT As Long = &H10
    Public Const XMIT_CLEAR As Long = &H20
    Public Const XMIT_KEYWORD As Long = &H40
    Public Const XMIT_BAUD As Long = &H80
    Public Const XMIT_INTERBYTE As Long = &H100
    Public Const XMIT_VOLTAGE As Long = &H200
    Public Const XMIT_SYSTEM_ID As Long = &H400
    Public Const XMIT_PULSE_INIT As Long = &H800

    Public Const FAST_INTERVAL As Integer = 100

    Public AlternateMethod As Boolean '14
    Public CarbInit As Boolean
    Public logging As Boolean
    Public logfilesize As Integer
    Public InterByteDelay As Short
    Public InterByteChanged As Boolean
    Public BaudRateChanged As Boolean
    Public BaudRate As Long
    Public RunMode As Boolean
    Public TestMode As Boolean
    Public Functional As Boolean
    Public TestRecvStarted As Boolean
    Public Message As String = ""
    Public TimeVal As Short
    Public Quit As Boolean
    Public FastInit As Boolean
    Public CustomTesterPresent As Boolean
    Public TesterPresent As Boolean
    Public Voltage_Selection As Short
    Public VoltageSelectionChanged As Boolean
    Public Loaded As Boolean
    Public Selected_Message As Short
    Public Tester_Present_Message As Short
    Public Number_of_Messages As Short
    Public Source_Address As Short
    Public Target_Address As Short
    Public SendHeader As String
    Public ErrorCode As Byte
    Public sStr As String = ""
    Public HexNum As Short
    Public inAddText As Boolean
    Public HundredMsec As Short
    Public in_Timer2 As Boolean
    Public Retries As Short
    Public TestChar As Byte
    Public SendQuery As Boolean
    Public Waiting As Boolean = False
    Public DSRwait As Boolean
    Public KeyWord As Integer
    Public Timestamp As Short
    Public RecvDataStamp As Short
    Public InMiddleOfMessage As Boolean
    Public fTopForm As fTop
    Public RecvState As Integer
    Public RecvChecksum As Short
    Public RecvByte As Integer
    Public RecvByte2 As Integer
    Public RecvExpectedLen As Integer
    Public PreRecvChecksum As Short
    Public XmitMask As Long
    Public ResponseWaitTime As Integer
    Public ResponseLoopTime As Integer
    Public RecvExpected As Long
    Public KeyInitFlag As Boolean
    Public MessageBytes As Integer
    Public VoltageArguments As String = ""
    Public FastInitArguments As String = ""
    Public SlowInitArguments As String = ""
    Public BaudArguments As String = ""
    Public InterbyteArguments As String = ""
    Public XmitTestSequence As Boolean = False
    Public InvisibleClear As Boolean = False
    Public goodport(256) As Boolean
    Public SystemID As Integer = 0
    Public PulseFast As Boolean = False
    Public PulseFastAmount As Integer = 0

    Public Sub SaveData()
        On Error GoTo writeerror
        FileOpen(1, My.Application.Info.DirectoryPath & "\KWP2000.CFG", OpenMode.Output)
        On Error GoTo writeerror2
        PrintLine(1, fTopForm.commPort.PortName)
        If FastInit = True Then
            PrintLine(1, "1")
        Else
            PrintLine(1, "0")
        End If
        PrintLine(1, Selected_Message)
        PrintLine(1, Source_Address)
        PrintLine(1, Target_Address)
        If TesterPresent = True Then
            PrintLine(1, "1")
        Else
            PrintLine(1, "0")
        End If
        If CustomTesterPresent = True Then
            PrintLine(1, "1")
        Else
            PrintLine(1, "0")
        End If
        PrintLine(1, Tester_Present_Message)
        PrintLine(1, Voltage_Selection)
        If Functional = True Then
            PrintLine(1, "1")
        Else
            PrintLine(1, "0")
        End If
        PrintLine(1, BaudRate)
        PrintLine(1, InterByteDelay)
        If AlternateMethod = True Then
            PrintLine(1, "1")
        Else
            PrintLine(1, "0")
        End If
        If PulseFast = True Then
            PrintLine(1, "1")
        Else
            PrintLine(1, "0")
        End If
        PrintLine(1, PulseFastAmount)
        FileClose(1)
        Exit Sub
writeerror:
        On Error Resume Next
        MsgBox("Error opening KWP2000.CFG for writing!")
        Exit Sub
writeerror2:
        On Error Resume Next
        MsgBox("Error writing to KWP2000.CFG!")
        FileClose(1)
    End Sub
    Public Sub Send_Message(ByRef SendMessage As String)
        Dim i As Short
        Dim x As Short
        x = 0
        For i = 1 To Len(SendHeader)
            x = x + Asc(Mid(SendHeader, i, 1))
            If x >= 256 Then x = x - 256
        Next i
        While fTop.commPort.BytesToWrite > 0 And Quit = False
            System.Windows.Forms.Application.DoEvents()
        End While
        While fTopForm.commPort.CtsHolding = False And Quit = False
            System.Windows.Forms.Application.DoEvents()
        End While
        If Quit = True Then Exit Sub
        fTopForm.commPort.Write(SendHeader)
        While fTop.commPort.BytesToWrite > 0 And Quit = False
            System.Windows.Forms.Application.DoEvents()
        End While
        For i = 1 To Len(SendMessage)
            x = x + Asc(Mid(SendMessage, i, 1))
            If x >= 256 Then x = x - 256
            While fTopForm.commPort.CtsHolding = False And Quit = False
                System.Windows.Forms.Application.DoEvents()
            End While
            If Quit = True Then Exit Sub
            fTopForm.commPort.Write(Mid(SendMessage, i, 1))
            While fTop.commPort.BytesToWrite > 0 And Quit = False
                System.Windows.Forms.Application.DoEvents()
            End While
        Next i
        While fTopForm.commPort.CtsHolding = False And Quit = False
            System.Windows.Forms.Application.DoEvents()
        End While
        If Quit = True Then Exit Sub
        fTopForm.commPort.Write(Chr(x) & Chr(255 - x))
        While fTop.commPort.BytesToWrite > 0 And Quit = False
            System.Windows.Forms.Application.DoEvents()
        End While
    End Sub

    Public Sub HandleRecvMessage()
        Select Case RecvExpected
            Case XMIT_STATUS
                ErrorCode = RecvByte
                If ErrorCode = Asc("O") Then
                    Add_Text(("ISO-14230 Box Ready."))
                Else
                    DisplayErrorCode()
                End If
            Case XMIT_REVISION
                Add_Text(("ISO-14230 RS232 Revision" & Str(RecvByte)))
            Case XMIT_RUN
                ErrorCode = RecvByte
                If ErrorCode = Asc("O") Then
                    Waiting=True
                    fTopForm.commPort.DtrEnable = True
                    If TestMode = True Then
                        fTopForm.bBtn5.Enabled = True
                    End If
                    DSRwait = True
                    While fTopForm.commPort.DsrHolding = False And Quit = False
                        System.Windows.Forms.Application.DoEvents()
                    End While
                    fTopForm.commPort.DiscardInBuffer()
                    TestRecvStarted = False
                    Waiting = False
                    RunMode = True
                    Add_Text("Run mode entered")
                Else
                    DisplayErrorCode()
                    fTopForm.commPort.DtrEnable = False
                End If
            Case XMIT_FAST_INIT
                ErrorCode = RecvByte
                If ErrorCode = Asc("O") Then
                    Add_Text("Fast initialized.")
                    Get_Keyword(True)
                Else
                    DisplayErrorCode()
                End If
            Case XMIT_SLOW_INIT
                ErrorCode = RecvByte
                If ErrorCode = Asc("O") Then
                    If AlternateMethod = True Then
                        fTop.commPort.DtrEnable = True
                        fTop.commPort.Handshake = IO.Ports.Handshake.RequestToSend
                        RunMode = True
                        Add_Text("Slow initialized.")
                    Else
                        Add_Text("Slow initialized.")
                        Get_Keyword((True))
                    End If
                Else
                    DisplayErrorCode()
                End If
            Case XMIT_CLEAR
                ErrorCode = RecvByte
                If ErrorCode = Asc("O") Then
                    If InvisibleClear = False Then
                        Add_Text(("ISO-14230 Buffers cleared."))
                    End If
                    InvisibleClear = False
                Else
                    DisplayErrorCode()
                End If
            Case XMIT_KEYWORD
                KeyWord = RecvByte
                KeyWord = KeyWord * 256
                KeyWord = KeyWord + RecvByte2
                If KeyInitFlag = True Then
                    Add_Text(("Initialized with Keyword " & Hex(KeyWord) & "H"))
                    Add_Text("Going to RUN Mode...")
                    'XmitMask = XmitMask Or XMIT_RUN
                    fTopForm.commPort.DtrEnable = True
                    DSRwait = True
                    While fTopForm.commPort.DsrHolding = False And Quit = False
                        System.Windows.Forms.Application.DoEvents()
                    End While
                    'fTopForm.commPort.DiscardInBuffer()
                    TestRecvStarted = False
                    Waiting = False
                    RunMode = True
                    Add_Text("Run mode entered")
                    fTopForm.SendTesterPresent()
                Else
                    Add_Text(("Most recent initialization had Keyword of " & Hex(KeyWord) & "H"))
                End If
            Case XMIT_BAUD
                    ErrorCode = RecvByte
                    If ErrorCode = Asc("O") Then
                        Add_Text(("Baud Rate" & Str(BaudRate) & " Sent OK."))
                    Else
                        DisplayErrorCode()
                    End If
            Case XMIT_INTERBYTE
                ErrorCode = RecvByte
                If ErrorCode = Asc("O") Then
                    Add_Text(("InterByte Delay" & Str(InterByteDelay) & " ms Sent OK."))
                Else
                    DisplayErrorCode()
                End If
            Case XMIT_VOLTAGE
                    ErrorCode = RecvByte
                    If ErrorCode = Asc("O") Then
                        If VoltageArguments = Chr(0) Then
                            Add_Text(("Voltage Selection Set to Auto-Detect OK."))
                        ElseIf VoltageArguments = Chr(12) Then
                            Add_Text(("Voltage Selection Set to 12V Load OK."))
                        ElseIf VoltageArguments = Chr(24) Then
                            Add_Text(("VoltageSelection Set to 24V Load OK."))
                        Else
                            Add_Text(("Voltage Selection Set to Unknown Value OK."))
                        End If
                    Else
                        DisplayErrorCode()
                    End If
            Case XMIT_SYSTEM_ID
                SystemID = RecvByte
                SystemID = SystemID * 256
                SystemID = SystemID + RecvByte2
                Add_Text(("Most recent initialization had System ID of " & Hex(SystemID) & "H"))
            Case XMIT_PULSE_INIT
                ErrorCode = RecvByte
                If ErrorCode = Asc("O") Then
                    Add_Text("Pulse initialized.")
                    fTop.commPort.DtrEnable = True
                    fTop.commPort.Handshake = IO.Ports.Handshake.RequestToSend
                    RunMode = True
                Else
                    DisplayErrorCode()
                End If
            Case Else
                Add_Text("Got Response; Expected Unknown Message " + RecvExpected.ToString())
        End Select
    End Sub

    Public Sub Get_Keyword(ByRef initflag As Boolean)
        On Error GoTo badport97
        KeyInitFlag = initflag
        If fTopForm.commPort.IsOpen() = False Then
            MsgBox("Need to open COM port first.")
            Exit Sub
        End If
        XmitMask = XmitMask Or XMIT_KEYWORD
        If (FastInit = False And AlternateMethod = True) Then
            XmitMask = XmitMask Or XMIT_SYSTEM_ID
        End If
        Exit Sub
badport97:
        On Error Resume Next
        Add_Text("The port is not accessible at this time.")
        Exit Sub
    End Sub

    Public Sub ProcessInitMode(ByVal recvstr As String)
        Dim val As String
        While recvstr <> ""
            val = Left$(recvstr, 1)
            recvstr = Mid$(recvstr, 2)
            PreRecvChecksum = RecvChecksum
            RecvChecksum += Asc(val)
            RecvChecksum = RecvChecksum And &HFF
            Select Case RecvState
                Case 0
                    RecvChecksum = Asc(val)
                    If (val = "R") Then
                        RecvState = 1
                    Else
                        'Add_Text("RX: Bad First Char")
                    End If
                Case 1
                    If (val = "E") Then
                        RecvState = 2
                    ElseIf (val = "R") Then
                        Add_Text("RX: Bad Header")
                        RecvChecksum = Asc(val)
                        RecvState = 1
                    Else
                        Add_Text("RX: Bad Header")
                        RecvState = 0
                    End If
                Case 2
                    If (val = "S") Then
                        RecvState = 3
                    ElseIf (val = "R") Then
                        RecvChecksum = Asc(val)
                        Add_Text("RX: Bad Header")
                        RecvState = 1
                    Else
                        Add_Text("RX: Bad Header")
                        RecvState = 0
                    End If
                Case 3
                    If (val = "P") Then
                        RecvState = 4
                    ElseIf (val = "R") Then
                        Add_Text("RX: Bad Header")
                        RecvChecksum = Asc(val)
                        RecvState = 1
                    Else
                        Add_Text("RX: Bad Header")
                        RecvState = 0
                    End If
                Case 4
                    If (val = ":") Then
                        RecvState = 5
                    ElseIf (val = "R") Then
                        Add_Text("RX: Bad Header")
                        RecvChecksum = Asc(val)
                        RecvState = 1
                    Else
                        Add_Text("RX: Bad Header")
                        RecvState = 0
                    End If
                Case 5
                    RecvByte = Asc(val)
                    If (RecvExpectedLen = 1) Then
                        RecvState = 8
                    Else
                        RecvState = 6
                    End If
                Case 6
                    If (RecvExpectedLen = 3) Then
                        RecvByte = Asc(val)
                        RecvState = 7
                    Else
                        RecvByte2 = Asc(val)
                        RecvState = 8
                    End If
                Case 7
                    RecvByte2 = Asc(val)
                    RecvState = 8
                Case 8
                    If PreRecvChecksum = Asc(val) Then
                        RecvState = 9
                        RecvChecksum = PreRecvChecksum
                    Else
                        RecvState = 0
                        Add_Text("RX: Bad Checksum")
                    End If
                Case 9
                    If (255 - PreRecvChecksum) = Asc(val) Then
                        RecvState = 0
                        Waiting = False
                        HandleRecvMessage()
                    Else
                        Add_Text("RX: Bad Checksum")
                        RecvState = 0
                    End If
                Case Else
                    Add_Text("RX: Bad State in State machine")
                    RecvState = 0
            End Select
        End While
    End Sub



    Public Sub DisplayErrorCode()
        Select Case ErrorCode
            Case &H0S : Add_Text(("Failed to assert K and L lines low."))
            Case &H1S : Add_Text(("Failed to assert K line low."))
            Case &H2S : Add_Text(("Failed to assert L line low."))
            Case &H3S : Add_Text(("Failed to release K and L lines high."))
            Case &H4S : Add_Text(("Failed to release K line high."))
            Case &H5S : Add_Text(("Failed to release L line high."))
            Case &H6S : Add_Text(("K and L lines are shorted low."))
            Case &H7S : Add_Text(("K line is shorted low."))
            Case &H8S : Add_Text(("L line is shorted low."))
            Case &H9S : Add_Text(("No response received from ECU to initialization."))
            Case &HAS : Add_Text(("Improper synchronization byte received."))
            Case &HBS : Add_Text(("Improper inverse address byte received."))
            Case &HCS : Add_Text(("Improper Start Communications Positive Response received."))
            Case &HDS : Add_Text(("Bad Start Communications Positive Response checksum."))
            Case &HES : Add_Text(("Error: Bus Busy."))
            Case &HFS : Add_Text(("Error K-Line Receive Buffer Overflow."))
            Case &H20S : Add_Text(("Received invalid checksum from PC."))
            Case &H21S : Add_Text(("Received invalid command from PC."))
            Case &H30S : Add_Text(("Receive (from PC to ISO-14230 box) buffer overflow."))
            Case &H31S : Add_Text(("Transmit (from ISO-14230 box to PC) buffer overflow."))
            Case &H4FS : Add_Text(("ISO-14230 Box status OK."))
            Case &HE0S : Add_Text(("FLASH ROM Checksum Error."))
            Case &HFFS : Add_Text(("Error communicating with ISO-14230 box."))
            Case Else : Add_Text(("ISO-14230 Box returned error code " & Hex(ErrorCode) & "H"))
        End Select
    End Sub

    Public Sub Add_Text(ByRef sStr As String)
        Dim pos As Integer
        inAddText = True
        If logging = True Then
            On Error GoTo badsave
            logfilesize = logfilesize + 4 + Len(TimeString) + Len(sStr)
            PrintLine(3, TimeString & ": " & sStr)
            GoTo donewithsave
badsave:
            On Error Resume Next
            MsgBox("Error Saving to Log File!  Saved " & VB6.Format(logfilesize, "#0") & " bytes already.", MsgBoxStyle.Critical, "Error")
            On Error GoTo badclose
            FileClose(3)
            GoTo donewithsave
badclose:
            On Error Resume Next
            MsgBox("Error closing Log File!", MsgBoxStyle.Critical, "Error")
            GoTo donewithsave
donewithsave:
        End If
        On Error GoTo noroom
        If Len(fTopForm.tTerminalWindow.Text) + Len(sStr) + Len(TimeString) + 2 + 2 > fTopForm.tTerminalWindow.MaxLength Then
            GoTo noroom
        End If
        fTopForm.tTerminalWindow.Text = fTopForm.tTerminalWindow.Text & TimeString & ": " & sStr & Chr(13) & Chr(10)
        fTopForm.tTerminalWindow.SelectionStart = Len(fTop.tTerminalWindow.Text) - 1
        fTopForm.tTerminalWindow.SelectionLength = 0 'forces cursor to end of text
        fTopForm.tTerminalWindow.ScrollToCaret()
        On Error Resume Next
        inAddText = False
        Exit Sub
noroom:
        pos = Len(fTopForm.tTerminalWindow.Text) / 8
        If pos <= Len(fTopForm.tTerminalWindow.Text) Then
            fTopForm.tTerminalWindow.Text = Right(fTopForm.tTerminalWindow.Text, (Len(fTopForm.tTerminalWindow.Text) - pos) + 1)
            fTopForm.tTerminalWindow.Text = fTopForm.tTerminalWindow.Text & TimeString & ": " & sStr & Chr(13) & Chr(10)
        Else
            fTopForm.tTerminalWindow.Text = TimeString & ": " & sStr & Chr(13) & Chr(10)
        End If
        fTopForm.tTerminalWindow.SelectionStart = Len(fTop.tTerminalWindow.Text) - 1
        fTopForm.tTerminalWindow.SelectionLength = 0 'forces cursor to end of text
        fTopForm.tTerminalWindow.ScrollToCaret()
        On Error Resume Next
        inAddText = False
    End Sub
End Module